#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire1500three4xi.py">
#<abstract4xi abstract = "fires to direction three and to distance 1500"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire1500three4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2three15004xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - ) - STUBS ONLY - ALL ARE IN FILES
# -------------------------------------------------------------------------------------------------    

shot2three15004xi = {
                1:'0x1456y-360z',
                2:'0x29y-1499z',
                3:'101x165y-1487z',
                4:'1030x897y-618z',
                5:'1046x762y-757z',
                6:'1047x976y-444z',
                7:'1056x1056y-139z',
                8:'107x412y-1438z',
                9:'1081x845y-604z',
                10:'1100x923y-430z',
                11:'1110x1000y-124z',
                12:'1129x791y-590z',
                13:'1150x867y-415z',
                14:'1162x941y-109z',
                15:'118x1351y-640z',
                16:'118x171y-1485z',
                17:'1198x808y-401z',
                18:'1211x879y-94z',
                19:'127x1227y-1017z',
                20:'133x419y-1433z',
                21:'136x177y-1483z',
                22:'14x19y-1499z',
                23:'152x1454y-331z',
                24:'153x1257y-802z',
                25:'155x181y-1480z',
                26:'160x425y-1429z',
                27:'16x88y-1497z',
                28:'174x183y-1478z',
                29:'17x367y-1454z',
                30:'180x1152y-942z',
                31:'188x429y-1424z',
                32:'189x1349y-626z',
                33:'195x184y-1475z',
                34:'1x44y-1499z',
                35:'215x183y-1473z',
                36:'216x431y-1420z',
                37:'21x1250y-828z',
                38:'220x1255y-790z',
                39:'229x1448y-316z',
                40:'236x180y-1470z',
                41:'242x1150y-930z',
                42:'246x432y-1415z',
                43:'24x101y-1496z',
                44:'24x30y-1499z',
                45:'257x176y-1467z',
                46:'261x1343y-613z',
                47:'276x430y-1410z',
                48:'287x1250y-777z',
                49:'304x1145y-919z',
                50:'305x1437y-302z',
                51:'306x426y-1404z',
                52:'332x1334y-599z',
                53:'337x421y-1399z',
                54:'34x114y-1495z',
                55:'355x1240y-764z',
                56:'367x1136y-907z',
                57:'368x413y-1394z',
                58:'36x39y-1499z',
                59:'37x380y-1450z',
                60:'381x1422y-287z',
                61:'398x403y-1388z',
                62:'403x1320y-585z',
                63:'421x1227y-751z',
                64:'429x1124y-895z',
                65:'429x391y-1382z',
                66:'455x1402y-272z',
                67:'45x126y-1493z',
                68:'460x377y-1376z',
                69:'474x1303y-571z',
                70:'47x1349y-653z',
                71:'488x1210y-738z',
                72:'490x360y-1370z',
                73:'491x1108y-883z',
                74:'49x48y-1498z',
                75:'4x59y-1498z',
                76:'4x7y-1499z',
                77:'520x342y-1364z',
                78:'529x1379y-257z',
                79:'544x1281y-557z',
                80:'552x1088y-871z',
                81:'554x1190y-725z',
                82:'57x137y-1492z',
                83:'59x392y-1446z',
                84:'602x1352y-243z',
                85:'612x1256y-543z',
                86:'613x1066y-858z',
                87:'619x1165y-712z',
                88:'62x55y-1497z',
                89:'672x1039y-846z',
                90:'673x1320y-228z',
                91:'680x1227y-529z',
                92:'682x1137y-699z',
                93:'71x148y-1490z',
                94:'731x1009y-834z',
                95:'742x1285y-213z',
                96:'745x1106y-685z',
                97:'746x1194y-515z',
                98:'76x1457y-346z',
                99:'77x61y-1496z',
                100:'788x976y-821z',
                101:'806x1071y-672z',
                102:'809x1246y-198z',
                103:'810x1157y-501z',
                104:'83x403y-1442z',
                105:'843x940y-808z',
                106:'85x157y-1489z',
                107:'865x1032y-658z',
                108:'873x1117y-487z',
                109:'875x1204y-183z',
                110:'87x1255y-815z',
                111:'897x900y-796z',
                112:'922x990y-645z',
                113:'92x65y-1495z',
                114:'933x1074y-473z',
                115:'937x1158y-168z',
                116:'949x857y-783z',
                117:'978x945y-631z',
                118:'991x1027y-459z',
                119:'998x1108y-153z',
                120:'998x811y-770z',
                121:'9x73y-1498z'}

                
 
# -----------------------------------------------------------------------------------------------------------
#<function4xi function = "fire1500three4xi" usage = "target function for chargethree4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -----------------------------------------------------------------------------------------------------------
def fire1500three4xi(queue2three, consumer_channel2three, publisher_channel2three):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE15000THREE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE15000THREE4XI -  QUEUE2THREE: ", queue2three)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE15000THREE4XI -  CONSUMER_CHANNEL2THREE: ", consumer_channel2three)
        #  
              
        print("\n (STEP 1A4/33) OF FIRE15000THREE4XI -  PUBLISHER_CHANNEL2THREE: ", publisher_channel2three)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE15000THREE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2three.put(shot2three15004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE15000THREE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE15000THREE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE15000THREE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4three = "<ack2put4xi>queue2three8shot2three15004xi</ack2put4xi>"
        else:
            message2send4three = "<nack2put4xi>queue2three<8shot2three15004xi/nack2put4xi>" 
            
        publisher_channel2three.send(message2send4three)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE15000THREE4XI -  SENT MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE15000THREE4XI *** FAILED TO SEND MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE15000THREE4XI - RETURNING QUEUE OBJECT QUEUE2THREE: ", queue2three, " - TIME: ", time4xi())  
        # 
            
    return queue2three    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire1500three4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                               
                